Index: src/Actions/MoleculeAction/BondFileAction.cpp
===================================================================
--- src/Actions/MoleculeAction/BondFileAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/MoleculeAction/BondFileAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * BondFileAction.cpp
@@ -6,11 +13,14 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/MoleculeAction/BondFileAction.hpp"
-#include "Actions/ActionRegistry.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -21,55 +31,20 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/MoleculeAction/BondFileAction.hpp"
 
-
-/****** MoleculeBondFileAction *****/
-
-// memento to remember the state when undoing
-
-//class MoleculeBondFileState : public ActionState {
-//public:
-//  MoleculeBondFileState(molecule* _mol,std::string _lastName) :
-//    mol(_mol),
-//    lastName(_lastName)
-//  {}
-//  molecule* mol;
-//  std::string lastName;
-//};
-
-const char MoleculeBondFileAction::NAME[] = "bond-file";
-
-MoleculeBondFileAction::MoleculeBondFileAction() :
-  Action(NAME)
-{}
-
-MoleculeBondFileAction::~MoleculeBondFileAction()
-{}
-
-void MoleculeBondFile(std::string &bondfile) {
-  ValueStorage::getInstance().setCurrentValue(MoleculeBondFileAction::NAME, bondfile);
-  ActionRegistry::getInstance().getActionByName(MoleculeBondFileAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* MoleculeBondFileAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryString(NAME, MapOfActions::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "BondFileAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr MoleculeBondFileAction::performCall() {
-  string filename;
   molecule *mol = NULL;
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
+  // obtain information
+  getParametersfromValueStorage();
 
   if(World::getInstance().countSelectedMolecules() == 1) {
     mol = World::getInstance().beginMoleculeSelection()->second;
-    DoLog(0) && (Log() << Verbose(0) << "Parsing bonds from " << filename << "." << endl);
-    ifstream input(filename.c_str());
+    DoLog(0) && (Log() << Verbose(0) << "Parsing bonds from " << params.bondfile << "." << endl);
+    ifstream input(params.bondfile.c_str());
     mol->CreateAdjacencyListFromDbondFile(&input);
     input.close();
@@ -104,2 +79,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/MoleculeAction/BondFileAction.def
===================================================================
--- src/Actions/MoleculeAction/BondFileAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/MoleculeAction/BondFileAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * BondFileAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class MoleculeListClass;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string)
+#define paramtokens (MoleculeBondFileAction::NAME)
+#define paramreferences (bondfile)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Molecule
+#define ACTIONNAME BondFile
+#define TOKEN "bond-file"
+
Index: src/Actions/MoleculeAction/BondFileAction.hpp
===================================================================
--- src/Actions/MoleculeAction/BondFileAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/MoleculeAction/BondFileAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,31 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
 
-class MoleculeListClass;
-
-void MoleculeBondFile(std::string &bondfile);
-
-class MoleculeBondFileAction : public Action {
-  friend void MoleculeBondFile(std::string &bondfile);
-
-public:
-  MoleculeBondFileAction();
-  virtual ~MoleculeBondFileAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
-
+#include "BondFileAction.def"
+#include "Action_impl_header.hpp"
 
 #endif // BONDFILEACTION_HPP
Index: src/Actions/MoleculeAction/ChangeNameAction.cpp
===================================================================
--- src/Actions/MoleculeAction/ChangeNameAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/MoleculeAction/ChangeNameAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ChangeNameAction.cpp
@@ -6,8 +13,11 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/MoleculeAction/ChangeNameAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
 #include "molecule.hpp"
@@ -18,55 +28,21 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/MoleculeAction/ChangeNameAction.hpp"
 
-/****** MoleculeChangeNameAction *****/
-
-// memento to remember the state when undoing
-
-class MoleculeChangeNameState : public ActionState {
-public:
-  MoleculeChangeNameState(molecule* _mol,std::string _lastName) :
-    mol(_mol),
-    lastName(_lastName)
-  {}
-  molecule* mol;
-  std::string lastName;
-};
-
-const char MoleculeChangeNameAction::NAME[] = "change-molname";
-
-MoleculeChangeNameAction::MoleculeChangeNameAction() :
-  Action(NAME)
-{}
-
-MoleculeChangeNameAction::~MoleculeChangeNameAction()
-{}
-
-void MoleculeChangeName(std::string &name) {
-  ValueStorage::getInstance().setCurrentValue(MoleculeChangeNameAction::NAME, name);
-  ActionRegistry::getInstance().getActionByName(MoleculeChangeNameAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* MoleculeChangeNameAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "ChangeNameAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr MoleculeChangeNameAction::performCall() {
-  string filename;
   molecule *mol = NULL;
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
+  // obtain information
+  getParametersfromValueStorage();
 
   if (World::getInstance().countSelectedMolecules() == 1) {
     mol = World::getInstance().beginMoleculeSelection()->second;
     string oldName = mol->getName();
-    mol->setName(filename);
-    return Action::state_ptr(new MoleculeChangeNameState(mol,oldName));
+    mol->setName(params.name);
+    return Action::state_ptr(new MoleculeChangeNameState(mol,params));
   } else
     return Action::failure;
@@ -77,7 +53,8 @@
 
   string newName = state->mol->getName();
-  state->mol->setName(state->lastName);
+  state->mol->setName(state->params.name);
+  state->params.name = newName;
 
-  return Action::state_ptr(new MoleculeChangeNameState(state->mol,newName));
+  return Action::state_ptr(_state);
 }
 
@@ -98,2 +75,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/MoleculeAction/ChangeNameAction.def
===================================================================
--- src/Actions/MoleculeAction/ChangeNameAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/MoleculeAction/ChangeNameAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * ChangeNameAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class MoleculeListClass;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string)
+#define paramtokens (MoleculeChangeNameAction::NAME)
+#define paramreferences (name)
+
+#define statetypes (molecule*)
+#define statereferences (mol)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Molecule
+#define ACTIONNAME ChangeName
+#define TOKEN "change-molname"
+
Index: src/Actions/MoleculeAction/ChangeNameAction.hpp
===================================================================
--- src/Actions/MoleculeAction/ChangeNameAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/MoleculeAction/ChangeNameAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,32 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
 
-class MoleculeListClass;
-
-void MoleculeChangeName(std::string &name);
-
-class MoleculeChangeNameAction : public Action {
-  friend void MoleculeChangeName(std::string &name);
-
-public:
-  MoleculeChangeNameAction();
-  virtual ~MoleculeChangeNameAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  MoleculeListClass *molecules;
-  static const char NAME[];
-};
-
+#include "ChangeNameAction.def"
+#include "Action_impl_header.hpp"
 
 #endif // CHANGENAMEACTION_HPP
Index: src/Actions/MoleculeAction/CopyAction.cpp
===================================================================
--- src/Actions/MoleculeAction/CopyAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/MoleculeAction/CopyAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,97 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * CopyAction.cpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "atom.hpp"
+#include "bond.hpp"
+#include "molecule.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <fstream>
+#include <string>
+
+using namespace std;
+
+#include "Actions/MoleculeAction/CopyAction.hpp"
+
+// and construct the stuff
+#include "CopyAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr MoleculeCopyAction::performCall() {
+  molecule *copy = NULL;
+
+  // obtain information
+  getParametersfromValueStorage();
+
+  copy = params.mol->CopyMolecule();
+  Vector *Center = params.mol->DetermineCenterOfAll();
+  *Center *= -1.;
+  *Center += params.position;
+  copy->Translate(Center);
+  delete(Center);
+
+  return Action::state_ptr(new MoleculeCopyState(copy,params));
+}
+
+Action::state_ptr MoleculeCopyAction::performUndo(Action::state_ptr _state) {
+  MoleculeCopyState *state = assert_cast<MoleculeCopyState*>(_state.get());
+
+  for (molecule::iterator AtomRunner = state->copy->begin(); !state->copy->empty(); AtomRunner = state->copy->begin()) {
+    for(BondList::iterator BondRunner = (*AtomRunner)->ListOfBonds.begin(); !(*AtomRunner)->ListOfBonds.empty(); BondRunner = (*AtomRunner)->ListOfBonds.begin())
+      delete(*BondRunner);
+    atom *Walker = *AtomRunner;
+    state->copy->erase(AtomRunner);
+    World::getInstance().destroyAtom(Walker);
+  }
+  World::getInstance().destroyMolecule(state->copy);
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr MoleculeCopyAction::performRedo(Action::state_ptr _state){
+  MoleculeCopyState *state = assert_cast<MoleculeCopyState*>(_state.get());
+
+  molecule *copy = state->params.mol->CopyMolecule();
+  Vector *Center = state->params.mol->DetermineCenterOfAll();
+  *Center *= -1.;
+  *Center += state->params.position;
+  copy->Translate(Center);
+  delete(Center);
+
+  return Action::state_ptr(new MoleculeCopyState(copy,state->params));
+}
+
+bool MoleculeCopyAction::canUndo() {
+  return true;
+}
+
+bool MoleculeCopyAction::shouldUndo() {
+  return true;
+}
+
+const string MoleculeCopyAction::getName() {
+  return NAME;
+}
+/** =========== end of function ====================== */
Index: src/Actions/MoleculeAction/CopyAction.def
===================================================================
--- src/Actions/MoleculeAction/CopyAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/MoleculeAction/CopyAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * CopyAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class MoleculeListClass;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (molecule *) (Vector)
+#define paramtokens (MoleculeCopyAction::NAME) ("position")
+#define paramreferences (mol) (position)
+
+#define statetypes (molecule *)
+#define statereferences (copy)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Molecule
+#define ACTIONNAME Copy
+#define TOKEN "copy-molecule"
+
Index: src/Actions/MoleculeAction/CopyAction.hpp
===================================================================
--- src/Actions/MoleculeAction/CopyAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/MoleculeAction/CopyAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,16 @@
+/*
+ * CopyAction.hpp
+ *
+ *  Created on: May 10, 2010
+ *      Author: heber
+ */
+
+#ifndef COPYACTION_HPP
+#define COPYACTION_HPP
+
+#include "Actions/Action.hpp"
+
+#include "CopyAction.def"
+#include "Action_impl_header.hpp"
+
+#endif // COPYACTION_HPP
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.cpp
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * FillWithMoleculeAction.cpp
@@ -6,8 +13,11 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/MoleculeAction/FillWithMoleculeAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
 #include "bondgraph.hpp"
@@ -15,5 +25,5 @@
 #include "config.hpp"
 #include "molecule.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -24,72 +34,22 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/MoleculeAction/FillWithMoleculeAction.hpp"
 
-/****** MoleculeFillWithMoleculeAction *****/
+// and construct the stuff
+#include "FillWithMoleculeAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr MoleculeFillWithMoleculeAction::performCall() {
 
-// memento to remember the state when undoing
+  // obtain information
+  getParametersfromValueStorage();
 
-//class MoleculeFillWithMoleculeState : public ActionState {
-//public:
-//  MoleculeFillWithMoleculeState(molecule* _mol,std::string _lastName) :
-//    mol(_mol),
-//    lastName(_lastName)
-//  {}
-//  molecule* mol;
-//  std::string lastName;
-//};
-
-const char MoleculeFillWithMoleculeAction::NAME[] = "fill-molecule";
-
-MoleculeFillWithMoleculeAction::MoleculeFillWithMoleculeAction() :
-  Action(NAME)
-{}
-
-MoleculeFillWithMoleculeAction::~MoleculeFillWithMoleculeAction()
-{}
-
-void MoleculeFillWithMolecule(std::string &fillername, Vector &distances, Vector &lengths, double MaxDistance, bool DoRotate) {
-  ValueStorage::getInstance().setCurrentValue(MoleculeFillWithMoleculeAction::NAME, fillername);
-  ValueStorage::getInstance().setCurrentValue("distances", distances);
-  ValueStorage::getInstance().setCurrentValue("lengths", lengths);
-  ValueStorage::getInstance().setCurrentValue("DoRotate", MaxDistance);
-  ValueStorage::getInstance().setCurrentValue("MaxDistance", DoRotate);
-  ActionRegistry::getInstance().getActionByName(MoleculeFillWithMoleculeAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* MoleculeFillWithMoleculeAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
-  dialog->queryVector("distances", false, ValueStorage::getInstance().getDescription("distances"));
-  dialog->queryVector("lengths", false, ValueStorage::getInstance().getDescription("lengths"));
-  dialog->queryBoolean("DoRotate", ValueStorage::getInstance().getDescription("DoRotate"));
-  dialog->queryDouble("MaxDistance", ValueStorage::getInstance().getDescription("MaxDistance"));
-
-  return dialog;
-}
-
-Action::state_ptr MoleculeFillWithMoleculeAction::performCall() {
-  string filename;
-  Vector distances;
-  Vector lengths;
-  double MaxDistance = -1.;
-  bool DoRotate = false;
-
-  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
-  ValueStorage::getInstance().queryCurrentValue("distances", distances);
-  ValueStorage::getInstance().queryCurrentValue("lengths", lengths);
-  ValueStorage::getInstance().queryCurrentValue("DoRotate", DoRotate);
-  ValueStorage::getInstance().queryCurrentValue("MaxDistance", MaxDistance);
-
-  DoLog(1) && (Log() << Verbose(1) << "Filling Box with water molecules, lengths(" << lengths[0] << "," << lengths[1] << "," << lengths[2] << "), distances (" << distances[0] << "," << distances[1] << "," << distances[2] << "), MaxDistance " << MaxDistance << ", DoRotate " << DoRotate << "." << endl);
+  DoLog(1) && (Log() << Verbose(1) << "Filling Box with water molecules, lengths(" << params.lengths[0] << "," << params.lengths[1] << "," << params.lengths[2] << "), distances (" << params.distances[0] << "," << params.distances[1] << "," << params.distances[2] << "), MaxDistance " << params.MaxDistance << ", DoRotate " << params.DoRotate << "." << endl);
   // construct water molecule
   molecule *filler = World::getInstance().createMolecule();
-  if (!filler->AddXYZFile(filename)) {
-    DoeLog(0) && (eLog()<< Verbose(0) << "Could not parse filler molecule from " << filename << "." << endl);
+  if (!filler->AddXYZFile(params.fillername)) {
+    DoeLog(0) && (eLog()<< Verbose(0) << "Could not parse filler molecule from " << params.fillername << "." << endl);
   }
-  filler->SetNameFromFilename(filename.c_str());
+  filler->SetNameFromFilename(params.fillername.c_str());
   molecule *Filling = NULL;
 //    atom *first = NULL, *second = NULL, *third = NULL;
@@ -113,6 +73,6 @@
   double distance[NDIM];
   for (int i=0;i<NDIM;i++)
-    distance[i] = distances[i];
-  Filling = FillBoxWithMolecule(World::getInstance().getMolecules(), filler, *(World::getInstance().getConfig()), MaxDistance, distance, lengths[0], lengths[1], lengths[2], DoRotate);
+    distance[i] = params.distances[i];
+  Filling = FillBoxWithMolecule(World::getInstance().getMolecules(), filler, *(World::getInstance().getConfig()), params.MaxDistance, distance, params.lengths[0], params.lengths[1], params.lengths[2], params.DoRotate);
   if (Filling != NULL) {
     Filling->ActiveFlag = false;
@@ -154,2 +114,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.def
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/MoleculeAction/FillWithMoleculeAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,26 @@
+/*
+ * FillWithMoleculeAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "LinearAlgebra/Vector.hpp"
+class MoleculeListClass;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string) (Vector) (Vector) (double) (bool)
+#define paramtokens (MoleculeFillWithMoleculeAction::NAME) ("distances") ("lengths") ("MaxDistance") ("DoRotate")
+#define paramreferences (fillername) (distances) (lengths) (MaxDistance) (DoRotate)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Molecule
+#define ACTIONNAME FillWithMolecule
+#define TOKEN "fill-molecule"
+
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.hpp
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/MoleculeAction/FillWithMoleculeAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,32 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
-#include "vector.hpp"
 
-class MoleculeListClass;
-
-void MoleculeFillWithMolecule(std::string &fillername, Vector &distances, Vector &lengths, double MaxDistance, bool DoRotate);
-
-class MoleculeFillWithMoleculeAction : public Action {
-  friend void MoleculeFillWithMolecule(std::string &fillername, Vector &distances, Vector &lengths, double MaxDistance, bool DoRotate);
-
-public:
-  MoleculeFillWithMoleculeAction();
-  virtual ~MoleculeFillWithMoleculeAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
-
+#include "FillWithMoleculeAction.def"
+#include "Action_impl_header.hpp"
 
 #endif // FILLWITHMOLECULEACTION_HPP
Index: src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp
===================================================================
--- src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * LinearInterpolationofTrajectoriesAction.cpp
@@ -6,13 +13,16 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
 #include "defs.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -23,72 +33,25 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp"
 
+// and construct the stuff
+#include "LinearInterpolationofTrajectoriesAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr MoleculeLinearInterpolationofTrajectoriesAction::performCall() {
+  molecule *mol = NULL;
 
-/****** MoleculeLinearInterpolationofTrajectoriesAction *****/
-
-// memento to remember the state when undoing
-
-//class MoleculeLinearInterpolationofTrajectoriesState : public ActionState {
-//public:
-//  MoleculeLinearInterpolationofTrajectoriesState(molecule* _mol,std::string _lastName) :
-//    mol(_mol),
-//    lastName(_lastName)
-//  {}
-//  molecule* mol;
-//  std::string lastName;
-//};
-
-const char MoleculeLinearInterpolationofTrajectoriesAction::NAME[] = "linear-interpolate";
-
-MoleculeLinearInterpolationofTrajectoriesAction::MoleculeLinearInterpolationofTrajectoriesAction() :
-  Action(NAME)
-{}
-
-MoleculeLinearInterpolationofTrajectoriesAction::~MoleculeLinearInterpolationofTrajectoriesAction()
-{}
-
-void MoleculeLinearInterpolationofTrajectories(std::string &filename, int start, int end, bool IdMapping) {
-  ValueStorage::getInstance().setCurrentValue(MoleculeLinearInterpolationofTrajectoriesAction::NAME, filename);
-  ValueStorage::getInstance().setCurrentValue("start-step", start);
-  ValueStorage::getInstance().setCurrentValue("end-step", end);
-  ValueStorage::getInstance().setCurrentValue("id-mapping", IdMapping);
-  ActionRegistry::getInstance().getActionByName(MoleculeLinearInterpolationofTrajectoriesAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* MoleculeLinearInterpolationofTrajectoriesAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryString(NAME, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryInt("start-step", MapOfActions::getInstance().getDescription("start-step"));
-  dialog->queryInt("end-step", MapOfActions::getInstance().getDescription("end-step"));
-  dialog->queryBoolean("id-mapping", MapOfActions::getInstance().getDescription("id-mapping"));
-
-  return dialog;
-}
-
-Action::state_ptr MoleculeLinearInterpolationofTrajectoriesAction::performCall() {
-  string filename;
-  molecule *mol = NULL;
-  int start = -1;
-  int end = -1;
-  bool IdMapping = true;
-
-  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
-  ValueStorage::getInstance().queryCurrentValue("start-step", start);
-  ValueStorage::getInstance().queryCurrentValue("end-step", end);
-  ValueStorage::getInstance().queryCurrentValue("id-mapping", IdMapping);
+  // obtain information
+  getParametersfromValueStorage();
 
   for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
     mol = iter->second;
-    DoLog(1) && (Log() << Verbose(1) << "Linear interpolation between configuration " << start << " and " << end << "." << endl);
-    if (IdMapping)
+    DoLog(1) && (Log() << Verbose(1) << "Linear interpolation between configuration " << params.start << " and " << params.end << "." << endl);
+    if (params.IdMapping)
       DoLog(1) && (Log() << Verbose(1) << "Using Identity for the permutation map." << endl);
-    if (!mol->LinearInterpolationBetweenConfiguration(start, end, filename, *(World::getInstance().getConfig()), IdMapping))
-      DoLog(2) && (Log() << Verbose(2) << "Could not store " << filename << " files." << endl);
+    if (!mol->LinearInterpolationBetweenConfiguration(params.start, params.end, params.filename, *(World::getInstance().getConfig()), params.IdMapping))
+      DoLog(2) && (Log() << Verbose(2) << "Could not store " << params.filename << " files." << endl);
     else
-      DoLog(2) && (Log() << Verbose(2) << "Steps created and " << filename << " files stored." << endl);
+      DoLog(2) && (Log() << Verbose(2) << "Steps created and " << params.filename << " files stored." << endl);
   }
   return Action::success;
@@ -120,2 +83,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.def
===================================================================
--- src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * LinearInterpolationofTrajectoriesAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class MoleculeListClass;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string) (int) (int) (bool)
+#define paramtokens (MoleculeLinearInterpolationofTrajectoriesAction::NAME) ("start-step") ("end-step") ("id-mapping")
+#define paramreferences (filename) (start) (end) (IdMapping)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Molecule
+#define ACTIONNAME LinearInterpolationofTrajectories
+#define TOKEN "linear-interpolate"
+
